<?php
    class Knjiga
    {
        public $id;
        public $naslov;
        public $pisac;
        
        public function __construct($id, $naslov, $pisac) {
            $this->id = $id;
            $this->naslov = $naslov;
            $this->pisac = $pisac;
        }
    }

    class Db
    {
        const host = "localhost";
        const dbname = "biblioteka";
        const user = "root";
        const pass = "";
        
        private $dbh;
        
        public function __construct() {
            $connstr = "mysql:host=" .self::host. ";dbname=" .self::dbname;
            $this->dbh = new PDO($connstr, self::user, self::pass);
        }
        
        public function __destruct() {
            $this->dbh = null;
        }
        
        public function dajSvePisce()
        {
            $sql = "SELECT * FROM pisac";
            $res = $this->dbh->query($sql);
            
            return $res->fetchAll(PDO::FETCH_ASSOC);
        }
        
        public function proveriKorisnika($username, $pass)
        {
            $sql = "SELECT * FROM pisac WHERE ime='$username' AND prezime='$pass'";
            $res = $this->dbh->query($sql);
            
            return $res->fetch(PDO::FETCH_ASSOC);
        }
        
        public function dajPiscaById($id)
        {
            $sql = "SELECT ime, prezime FROM pisac WHERE id=$id";
            $res = $this->dbh->query($sql);
            $pisac = $res->fetch(PDO::FETCH_ASSOC);
            
            return $pisac['ime']." ".$pisac['prezime'];
        }
        
        public function pretraziKnjige($naslov = null)
        {
            $sql = "SELECT * FROM knjiga";
            
            if($naslov != null)
            {
                $sql .= " WHERE naslov LIKE '%$naslov%'";
            }
            
            $res = $this->dbh->query($sql);
            $niz = $res->fetchAll(PDO::FETCH_ASSOC);
            
            $knjige = [];
            foreach ($niz as $knjiga)
            {
                $id = $knjiga['id'];
                $naslov = $knjiga['naslov'];
                
                $idPisca = $knjiga['pisac_id'];
                $ime_prezime_pisca = $this->dajPiscaById($idPisca);
                
                $knjige[] = new Knjiga($id, $naslov, $ime_prezime_pisca);
            }
            
            return json_encode($knjige);
        }
        
        public function pretraziKnjigePoPiscu($pisac = null)
        {
            $sql = "SELECT * FROM pisac p JOIN knjiga k ON p.id = k.pisac_id";
            
            if($pisac != null)
            {
                $sql .= " WHERE p.ime = '%$pisac%' OR p.prezime = '%$pisac%'";
            }
            
            $res = $this->dbh->query($sql);
            $niz = $res->fetchAll(PDO::FETCH_ASSOC);
            
            $knjige = [];
            foreach ($niz as $knjiga)
            {
                $id = $knjiga['id'];
                $naslov = $knjiga['naslov'];
                
                $idPisca = $knjiga['pisac_id'];
                $ime_prezime_pisca = $this->dajPiscaById($idPisca);
                
                $knjige[] = new Knjiga($id, $naslov, $ime_prezime_pisca);
            }
            
            return json_encode($knjige);
        }
        
        public function dajKnjigePisca($pisacID)
        {
            $sql = "SELECT * FROM knjiga WHERE pisac_id = $pisacID";
            $res = $this->dbh->query($sql);
            return $res->fetchAll(PDO::FETCH_ASSOC);
        }
        
        public function obrisiKnjigu($idKnjige)
        {
            $sql = "DELETE FROM knjiga WHERE id = $idKnjige";
            $this->dbh->exec($sql);
        }
        
        public function obrisiPisca($id)
        {
            $knjige = $this->dajKnjigePisca($id);
            foreach ($knjige as $knjiga)
            {
                $this->obrisiKnjigu($knjiga['id']);
            }
            
            $sql = "DELETE FROM pisac WHERE id=$id";
            $this->dbh->exec($sql);
        }
    }
?>