<?php

class Knjiga
{
        public $id;
        public $naslov;
        public $datum;
        public $autor;
        public $uloga;
       
        
        public function __construct($id, $naslov, $datum, $autor, $uloga) {
            $this->id = $id;
            $this->naslov=$naslov;
            $this->datum=$datum;
            $this->autor=$autor;
            $this->uloga = $uloga;
        }
}

class Db
{
    
    const ime_hosta = 'localhost';
    const korisnik = 'root';
    const sifra = "";
    const ime_baze = "biblioteka";
 
    private $dbh;
    
    function __construct() {
    try {
        $konekcioni_string="mysql:host=".self::ime_hosta.";dbname=".self::ime_baze;
        $this->dbh = new PDO($konekcioni_string, self::korisnik, self::sifra);
    }
    catch(PDOException $e) {
        echo "GRESKA: ";
        echo $e->getMessage();
        }
    }
    // Zadatak destruktora je zatvaranje konekcije prema bazi
    function __destruct() {
        $this->dbh = null;
    }
    
    public function provera($username, $pass) {
        $sql = "SELECT * FROM pisac WHERE ime='$username' and prezime='$pass'";
        $upit = $this->dbh->query($sql);
        
        return $upit->fetch(PDO::FETCH_ASSOC);
    }
    
      public function dajKorisnika($id) {
        $sql = "SELECT * FROM pisac WHERE id=$id";
        $upit = $this->dbh->query($sql);
        
        return $upit->fetch(PDO::FETCH_ASSOC);
    }
    
    public function dajSvePisce() {
        $sql = "SELECT * FROM pisac";
        $upit = $this->dbh->query($sql);
        
        return $upit->fetchAll(PDO::FETCH_ASSOC);
    }
    
    public function pretragaNaslov($naslov)
    {
        $sql = "SELECT p.uloga, p.id, k.dat_izdavanja, k.naslov, p.ime, p.prezime FROM knjiga k join pisac p on k.pisac_id=p.id WHERE k.naslov LIKE '%$naslov%'";
        $pdo_izraz= $this->dbh->query($sql);
        
        $niz = $pdo_izraz->fetchAll(PDO::FETCH_ASSOC);
        $knjige = [];
        foreach($niz as $knjiga) {
            $id= $knjiga['id'];
            $naslov = $knjiga['naslov'];
            $datum = $knjiga['dat_izdavanja'];
            $pisac=$knjiga['ime']." ".$knjiga['prezime'];
            $uloga=$knjiga['uloga'];
            $knjige[] = new Knjiga($id, $naslov, $datum, $pisac, $uloga);
        }
        return json_encode($knjige);
    }
    
    
     public function pretragaPisac($pisac)
    {
        $sql = "SELECT p.uloga, p.id, k.dat_izdavanja, k.naslov, p.ime, p.prezime FROM knjiga k join pisac p on k.pisac_id=p.id ";
        
        $sql .= " WHERE p.ime LIKE '%$pisac%' or p.prezime LIKE '%$pisac%'";
        $pdo_izraz= $this->dbh->query($sql);
        
        
        $niz = $pdo_izraz->fetchAll(PDO::FETCH_ASSOC);
        $knjige = [];
        foreach($niz as $knjiga) {
            $id= $knjiga['id'];
            $naslov = $knjiga['naslov'];
            $datum = $knjiga['dat_izdavanja'];
            $pisac=$knjiga['ime']." ".$knjiga['prezime'];
            $uloga=$knjiga['uloga'];
            $knjige[] = new Knjiga($id, $naslov, $datum, $pisac, $uloga);
        }
        return json_encode($knjige);
    }
    
    
    public function obrisi($id)
    {
     
        $sql="DELETE FROM knjiga WHERE pisac_id=$id";
        $this->dbh->exec($sql);
        
         $sql="DELETE FROM pisac WHERE id=$id";
        $this->dbh->exec($sql);
    }
}