<?php

class Knjiga {
    public $id;
    public $naslov;
    public $datum;
    public $pisacID;

    public function __construct($id, $naslov, $datum, $pisacID) {
        $this->id = $id;
        $this->naslov = $naslov;
        $this->datum = $datum;
        $this->pisacID = $pisacID;
    }
}

class biblioteka_db {
// Konstante
 const ime_hosta = 'localhost';
 const korisnik = 'root';
 const sifra = '';
 const ime_baze = "biblioteka";

 private $dbh; // konekcija prema bazi


 function __construct() {
    try {
         $konekcioni_string="mysql:host=".self::ime_hosta.";dbname=".self::ime_baze;
         $this->dbh = new PDO($konekcioni_string, self::korisnik, self::sifra);
    }
    catch(PDOException $e) {
        echo "GRESKA: ";
        echo $e->getMessage();
    }
 }
 // Zadatak destruktora je zatvaranje konekcije prema bazi
 function __destruct() {
    $this->dbh = null;
 }
 
 public function prikazPisaca() {
    try {
        $sql = "SELECT id, ime, prezime, uloga FROM pisac";

        $pdo_izraz = $this->dbh->query($sql);
        $niz = $pdo_izraz->fetchALL(PDO::FETCH_ASSOC);
        
        
        foreach($niz as $pisac) {
            echo "<input type='radio' name='' value='' id='".$pisac['id']."'/>";
            echo $pisac['ime'].$pisac['prezime']."</td>";
            echo "<br>";
        }
    }
    catch(PDOException $e) {
        echo "GRESKA: ";
        echo $e->getMessage();
    }
 }

 public function stampaj_tabelu_knjiga($naslov_kriterijum=NULL, $pisac_kriterijum=NULL) {
    try {       
        $sql = "SELECT id, ime, prezime, uloga FROM pisac";
        
        if ( isset ($pisac_kriterijum) ) {
            $sql.=" WHERE ime LIKE '%$pisac_kriterijum%' OR prezime LIKE '%$pisac_kriterijum%'";
        }
        $pdo_izraz = $this->dbh->query($sql);
        $niz = $pdo_izraz->fetchALL(PDO::FETCH_ASSOC);   
       
       
  
        echo "<table cellpadding='5' border='1'>";
        foreach($niz as $pisac) {
            echo "<tr><td><b>".$pisac['ime']." ".$pisac['prezime']."</b></td>";
            
            $idpisca = $pisac['id'];
            
            $sql2 = "SELECT id, naslov, dat_izdavanja, pisac_id FROM knjiga WHERE pisac_id='$idpisca'";
        
            if ( isset ($naslov_kriterijum) ) {
                $sql2.=" AND naslov LIKE '%$naslov_kriterijum%'";
            }
            $pdo_izraz2 = $this->dbh->query($sql2);
            $niz2 = $pdo_izraz2->fetchALL(PDO::FETCH_ASSOC);
            
            
            foreach($niz2 as $knjiga) {
                    echo "<tr><td><b>".$knjiga['naslov']."</b></td>";
            }
            
            echo "<td><input type='button' id='".$pisac['id']."' value='brisi' onclick='brisi(this.id)'></td>";
            
            }
        echo "</table>";
    }
    catch(PDOException $e) {
        echo "GRESKA: ";
        echo $e->getMessage();
    }
}

 
 
public function PretraziKnjige($naslov = null)
{
    $sql = "SELECT * FROM knjiga ";

    if($naslov != null)
    {
    $sql .= " WHERE naslov LIKE '%$naslov%'";
    }

    $pdo_izraz = $this->dbConnection->query($sql);
    $niz = $pdo_izraz->fetchALL(PDO::FETCH_ASSOC);
    $knjige = [];
    foreach($niz as $knjiga) {
    $id = $knjiga['id'];
    $naslov = $knjiga['naslov'];
    $autor = $knjiga['autor'];
    $godina = $knjiga['godina'];

    $knjige[] = new Knjiga($id, $naslov, $autor, $godina);
    }

    return json_encode($knjige);
}


 

    public function dodaj($naslov, $autor, $godina) {
        try {
            $sql = "INSERT INTO knjiga(naslov,autor,godina)";
            $sql.= "VALUES ('$naslov', '$autor', '$godina')";
            $pdo_izraz = $this->dbh->exec($sql);
            return true;
        }
        catch(PDOException $e) {
            echo "GRESKA: ";
            echo $e->getMessage();
            return false;
        }
    }
 

    public function brisi($id) {
        try {
            $sql = "DELETE FROM pisac WHERE id=$id";
            $pdo_izraz = $this->dbh->exec($sql);
            
            $sql2 = "DELETE FROM knjige WHERE pisac_id=$id";
            $pdo_izraz2 = $this->dbh->exec($sql2);
            
            return true;
        }
        catch(PDOException $e) {
            echo "GRESKA: ";
            echo $e->getMessage();
            return false;
        }
    }
 
    
 public function izmeni($id, $naslov, $autor, $godina) {
 try {
 $sql = "UPDATE knjiga SET naslov=:naslov, ";
 $sql.= "autor=:autor, godina=:godina ";
 $sql.= "WHERE id=:id";
 $pdo_izraz = $this->dbh->prepare($sql);
 $pdo_izraz->bindParam(':id', $id);
 $pdo_izraz->bindParam(':naslov', $naslov);
 $pdo_izraz->bindParam(':autor', $autor);
 $pdo_izraz->bindParam(':godina', $godina);
 $pdo_izraz->execute();
 return true;
 }
 catch(PDOException $e) {
 echo "GRESKA: ";
 echo $e->getMessage();
 return false;
 }
 }
 /*
 * Metoda koja uzima iz baze podatke (id, naslov, autor, godina) o knjizi
 * sa ID-om $id i vraca ih u obliku asocijativnog niza
 */
 public function uzmi_podatke_o_knjizi($id) {
 try {
 $sql = "SELECT * FROM knjiga WHERE id=$id";
 $pdo_izraz = $this->dbh->query($sql);
 $obj = $pdo_izraz->fetch(PDO::FETCH_ASSOC);
 return $obj;
 }
 catch(PDOException $e) {
 echo "GRESKA: ";
 echo $e->getMessage();
 }
 }
} // Kraj klase Knjiga_db
?>

