<?php
class Db
{
    const host = "localhost";
    const dbName = "biblioteka";
    const user = "root";
    const pass = "";
    
    private $dbh ;
    
    function __construct() {
        try{
            $connStr = "mysql:host=".self::host.";dbname=".self::dbName;
            $this->dbh = new PDO($connStr, self::user, self::pass);
        } catch (Exception $ex) {
            echo "GRESKA PRI KONEKCIJI: ".$ex;
        }
    }
    
    function __destruct() {
        $this->dbh = null;
    }
    
    function dajPisce()
    {
        $sql = "select * from pisac";
        $upit = $this->dbh->query($sql);
        return $upit->fetchAll(PDO::FETCH_ASSOC);
    }
    function dajKnjige()
    {
        $sql = "select * from knjiga";
        $upit = $this->dbh->query($sql);
        return $upit->fetchAll(PDO::FETCH_ASSOC);
    }
    function dajKnjigePoAutoru($id)
    {
        $sql = "select * from knjiga where pisac_id = $id";
        $upit = $this->dbh->query($sql);
        return $upit->fetchAll(PDO::FETCH_ASSOC);
    }
    function dajPisca($id)
    {
        $sql = "select * from pisac where id=$id";
        $upit = $this->dbh->query($sql);
        return $upit->fetch(PDO::FETCH_ASSOC);
    }
    function dajKnjigu($id)
    {
        $sql = "select * from knjiga where id=$id";
        $upit = $this->dbh->query($sql);
        return $upit->fetch(PDO::FETCH_ASSOC);
    }
    
    function login($user, $pass)
    {
        $sql = "select * from pisac where ime = '$user' and prezime= '$pass'";
        $upit = $this->dbh->query($sql);
        return $upit->fetch(PDO::FETCH_ASSOC);
    }
    
    function dajListuKnjiga()
    {
        $sql = "select * from pisac";
        $upit = $this->dbh->query($sql);
        $pisci = $upit->fetchAll(PDO::FETCH_ASSOC);
        $niz = [];
        foreach($pisci as $pisac)
        {
            $id = $pisac['id'];
            $ime = $pisac['ime'];
            $prezime = $pisac['prezime'];
            $uloga = $pisac['uloga'];
            $knjige = $this->dajKnjigePoAutoru($pisac['id']);
            $nizKnjiga = [];
            foreach($knjige as $knjiga)
            {
                $id = $knjiga['id'];
                $naslov = $knjiga['naslov'];
                $dat = $knjiga['dat_izdavanja'];
                $pisac = $knjiga['pisac_id'];
                $nizKnjiga[] = new Knjiga($id, $naslov, $dat,$pisac);
            }
            $niz[] = new Pisac($id, $ime, $prezime, $uloga, $nizKnjiga);
            return json_encode($niz);
        }
    }
    
    function pretragaPoPiscu($string)
    {
        $sql = "select * from pisac where ime like '%$string%' or prezime like '%$string%'";
        $upit = $this->dbh->query($sql);
        $pisci = $upit->fetchAll(PDO::FETCH_ASSOC);
        $niz = [];
        foreach($pisci as $pisac)
        {
            $id = $pisac['id'];
            $ime = $pisac['ime'];
            $prezime = $pisac['prezime'];
            $uloga = $pisac['uloga'];
            $knjige = $this->dajKnjigePoAutoru($pisac['id']);
            $nizKnjiga = [];
            foreach($knjige as $knjiga)
            {
                $id = $knjiga['id'];
                $naslov = $knjiga['naslov'];
                $dat = $knjiga['dat_izdavanja'];
                $pisac = $knjiga['pisac_id'];
                $nizKnjiga[] = new Knjiga($id, $naslov, $dat,$pisac);
            }
            $niz[] = new Pisac($id, $ime, $prezime, $uloga, $nizKnjiga);
            return json_encode($niz);
        }
    }
    
    function pretragaPoKnjizi($string)
    {
        $sql = "select * from pisac";
        $upit = $this->dbh->query($sql);
        $pisci = $upit->fetchAll(PDO::FETCH_ASSOC);
        $niz = [];
        foreach($pisci as $pisac)
        {
            $id = $pisac['id'];
            $ime = $pisac['ime'];
            $prezime = $pisac['prezime'];
            $uloga = $pisac['uloga'];
            $knjige = $this->dajKnjigePoAutoruIImenu($pisac['id'], $string);
            $nizKnjiga = [];
            foreach($knjige as $knjiga)
            {
                $id = $knjiga['id'];
                $naslov = $knjiga['naslov'];
                $dat = $knjiga['dat_izdavanja'];
                $pisac = $knjiga['pisac_id'];
                $nizKnjiga[] = new Knjiga($id, $naslov, $dat,$pisac);
            }
            $niz[] = new Pisac($id, $ime, $prezime, $uloga, $nizKnjiga);
            return json_encode($niz);
        }
    }
    
    function dajKnjigePoAutoruIImenu($pisac, $string)
    {
        $sql = "select * from knjiga where pisac_id= '$pisac' and naslov like '%$string%'";
        $upit = $this->dbh->query($sql);
        return $upit->fetchAll(PDO::FETCH_ASSOC);
    }
}


class Pisac
{
    public $id;
    public $ime;
    public $prezime;
    public $uloga;
    public $knjige;
    
    function __construct($id, $ime, $prezime, $uloga, $knjige) {
        $this->id= $id;
        $this->ime= $ime;
        $this->prezime= $prezime;
        $this->uloga= $uloga;
        $this->knjige= $knjige;
    }
}
class Knjiga
{
    public $id;
    public $naslov;
    public $dat_izdavanja;
    public $pisac_id;
    
    function __construct($id, $naslov, $dat_izdavanja, $pisac_id) {
        $this->id= $id;
        $this->naslov= $naslov;
        $this->dat_izdavanja= $dat_izdavanja;
        $this->pisac_id=$pisac_id;
    }
}
?>