<?php

    class Pisac {
        public $id;
        public $ime;
        public $prezime;
        public $uloga;
        public $brojKnjiga;
        public $knjiga;
        
        function __construct($id, $ime, $prezime, $uloga, $brojKnjiga, $knjiga) {
            $this->id = $id;
            $this->ime = $ime;
            $this->prezime = $prezime;
            $this->uloga = $uloga;
            $this->brojKnjiga = $brojKnjiga;
            $this->knjiga = $knjiga;
        }
    }

    class Db {
        
        const hostname = 'localhost';
        const username = 'root';
        const password = '';
        const database = 'biblioteka';
        
        private $dbh;
        
        function __construct() {
            try {
                $connection_string = "mysql:host=".self::hostname.";dbname=".self::database;
                $this->dbh = new PDO($connection_string, self::username, self::password);
            } catch (PDOException $ex) {
                die($ex->getMessage());
            }
        }
        
        function __destruct() {
            $this->dbh = null;
        }
        
        function getAllWriters() {
            try {
                $sql = "select * from pisac";
                $pdo_expression = $this->dbh->query($sql);
                $array = $pdo_expression->fetchAll(PDO::FETCH_ASSOC);
                return $array;
            } catch (PDOException $ex) {
                die($ex->getMessage());
            }
        }
        
        function loginCheck($user, $pass) {
            try {
                $sql = "select * from pisac where ime='$user' and prezime='$pass'";
                $pdo_expression = $this->dbh->query($sql);
                $obj = $pdo_expression->fetch(PDO::FETCH_ASSOC);
                return $obj;
            } catch (PDOException $ex) {
                die($ex->getMessage());
            }
        }
        
        function getWriterById($id) {
            try {
                $sql = "select * from pisac where id=$id";
                $pdo_expression = $this->dbh->query($sql);
                $obj = $pdo_expression->fetch(PDO::FETCH_ASSOC);
                return $obj;
            } catch (PDOException $ex) {
                die($ex->getMessage());
            }
        }
        
        function getBookById($id) {
            try {
                $sql = "select * from knjiga where id=$id";
                $pdo_expression = $this->dbh->query($sql);
                $obj = $pdo_expression->fetch(PDO::FETCH_ASSOC);
                return $obj;
            } catch (PDOException $ex) {
                die($ex->getMessage());
            }
        }
        
        function getNumberOfBooksForWriterID($id) {
            try {
                $sql = "SELECT COUNT(*) as brKnjiga FROM knjiga where pisac_id=$id";
                $pdo_expression = $this->dbh->query($sql);
                $obj = $pdo_expression->fetch(PDO::FETCH_ASSOC);
                return $obj['brKnjiga'];
            } catch (PDOException $ex) {
                die($ex->getMessage());
            }
        }
        
        function showTable() {
            try {
                $sql = "SELECT pisac.id as idP, ime, prezime, uloga, knjiga.id as idK, naslov FROM pisac JOIN knjiga ON pisac.id = knjiga.pisac_id";
                $pdo_expression = $this->dbh->query($sql);
                $array = $pdo_expression->fetchAll(PDO::FETCH_ASSOC);
                $niz = [];
                foreach($array as $arr) {
                    $id = $arr['idP'];
                    $ime = $arr['ime'];
                    $prezime = $arr['prezime'];
                    $uloga = $arr['uloga'];
                    $brojKnjiga = $this->getNumberOfBooksForWriterID($id);
                    $knjiga = $this->getBookById($arr['idK']);
                    $niz[] = new Pisac($id, $ime, $prezime, $uloga, $brojKnjiga, $knjiga);
                }
                return json_encode($niz);
            } catch (PDOException $ex) {
                die($ex->getMessage());
            }
        }
        
        function showTableByWriter($k) {
            try {
                $sql = "SELECT pisac.id as idP, ime, prezime, uloga, knjiga.id as idK, naslov FROM pisac JOIN knjiga ON pisac.id = knjiga.pisac_id where ime LIKE '%$k%' or prezime LIKE '%$k%'";
                $pdo_expression = $this->dbh->query($sql);
                $array = $pdo_expression->fetchAll(PDO::FETCH_ASSOC);
                $niz = [];
                foreach($array as $arr) {
                    $id = $arr['idP'];
                    $ime = $arr['ime'];
                    $prezime = $arr['prezime'];
                    $uloga = $arr['uloga'];
                    $brojKnjiga = $this->getNumberOfBooksForWriterID($id);
                    $knjiga = $this->getBookById($arr['idK']);
                    $niz[] = new Pisac($id, $ime, $prezime, $uloga, $brojKnjiga, $knjiga);
                }
                return json_encode($niz);
            } catch (PDOException $ex) {
                die($ex->getMessage());
            }
        }
        
        function showTableByBook($k) {
            try {
                $sql = "SELECT pisac.id as idP, ime, prezime, uloga, knjiga.id as idK, naslov FROM pisac JOIN knjiga ON pisac.id = knjiga.pisac_id where naslov LIKE '%$k%'";
                $pdo_expression = $this->dbh->query($sql);
                $array = $pdo_expression->fetchAll(PDO::FETCH_ASSOC);
                $niz = [];
                foreach($array as $arr) {
                    $id = $arr['idP'];
                    $ime = $arr['ime'];
                    $prezime = $arr['prezime'];
                    $uloga = $arr['uloga'];
                    $brojKnjiga = $this->getNumberOfBooksForWriterID($id);
                    $knjiga = $this->getBookById($arr['idK']);
                    $niz[] = new Pisac($id, $ime, $prezime, $uloga, $brojKnjiga, $knjiga);
                }
                return json_encode($niz);
            } catch (PDOException $ex) {
                die($ex->getMessage());
            }
        }
        
    }

?>