<?php

class Pisac
{
    public $ime;
    public $prezime;
    public $knjige;
            
    function __construct($ime, $prezime, $knjige) {
        $this->ime = $ime;
        $this->prezime = $prezime;
        $this->knjige = $knjige;
    }
}

class Knjiga
{
    public $naslov;
    
    function __construct($naslov)
    {
        $this->naslov = $naslov;
    }
}

class DB
{
    const hostname = "localhost";
    const dbname = "biblioteka";
    const username = "root";
    const password = "";
    
    private $dbh;
    
    function __construct() {
        try {
            $connStr = "mysql:host=".self::hostname.";dbname=".self::dbname;
            $this->dbh = new PDO($connStr, self::username, self::password);
        } catch (Exception $ex) {
            die($ex->getMessage());
        }
    }
    
    function __destruct() {
        $this->dbh = null;
    }
    
    function dajSvePisce()
    {
        try {
            $sql = "select * from pisac";
            $upit = $this->dbh->query($sql);
            return $upit->fetchAll(PDO::FETCH_ASSOC);
        } catch (Exception $ex) {
            die($ex->getMessage());
        }
    }
    
    function dajPiscaPoId($idP)
    {
        try {
            $sql = "select * from pisac where id = $idP";
            $upit = $this->dbh->query($sql);
            $rez = $upit->fetch(PDO::FETCH_ASSOC);
            //echo $sql;
           
            $ime = $rez['ime'];
            $prezime = $rez['prezime'];
            $knjige = [];
            $pisac = new Pisac($ime, $prezime, $knjige);
            
            return json_encode($pisac);
        } catch (Exception $ex) {
            die($ex->getMessage());
        }
    }
    
    function proveriKorisnika($ime, $pass)
    {
        try {
            $sql = "select * from pisac where ime = '$ime' and prezime = '$pass'";
            $upit = $this->dbh->query($sql);
            return $upit->fetch(PDO::FETCH_ASSOC);
        } catch (Exception $ex) {
            die($ex->getMessage());
        }
    }
    
    function korPoId($id)
    {
        try {
            $sql = "select * from pisac where id = $id";
            $upit = $this->dbh->query($sql);
            return $upit->fetch(PDO::FETCH_ASSOC);
        } catch (Exception $ex) {
            die($ex->getMessage());
        }
    }
    
    function dajKnjigePisca($id)
    {
        try {
            $sql = "select * from knjiga where pisac_id = $id";
            $upit = $this->dbh->query($sql);
            return $upit->fetchAll(PDO::FETCH_ASSOC);
        } catch (Exception $ex) {
            die($ex->getMessage());
        }
    }
    
    function dajPoPiscu($str)
    {
        try {
            $sql = "select * from pisac where ime like '%$str%' or prezime like '%$str%'";
            $upit = $this->dbh->query($sql);
            $rez =  $upit->fetchAll(PDO::FETCH_ASSOC);
            
            foreach ($rez as $r)
            {
                $ime = $r['ime'];
                //echo $ime;
                $prezime = $r['prezime'];
                $id = $r['id'];
                $knjige = $this->dajKnjigePisca($id);
                $pisac = new Pisac($ime, $prezime, $knjige);
                
                return json_encode($pisac);
            }
            
        } catch (Exception $ex) {
            die($ex->getMessage());
        }
    }
}

?>
