<?php

    class Pisac
    {
        public $id;
        public $ime;
        public $prezime;
        public $uloga;
        public $knjige;
        
        
        function __construct($id, $ime, $prezime, $uloga, $knjige) {
            $this->id = $id;
            $this->ime = $ime;
            $this->prezime = $prezime;
            $this->uloga = $uloga;
            $this->knjige = $knjige;
        }
    }
    
    class Knjiga
    {
        public $id;
        public $naslov;
        public $dat;
        public $pisac_id;
        
        function __construct($id, $naslov, $dat, $pis) {
            $this->id = $id;
            $this->naslov = $naslov;
            $this->dat = $dat;
            $this->pisac_id = $pis;
        }
    }
    
    class Db
    {
        private $host = 'localhost';
        private $user = 'root';
        private $pass = '';
        private $dbname = 'biblioteka';
        
        private $dbh;
        
        function __construct() {
            try
            {
                $conStr = "mysql:host=".$this->host."; dbname=".$this->dbname;
                $this->dbh = new PDO($conStr, $this->user, $this->pass);
            } catch (Exception $ex) {
                die("Neuspesno povezivanje na bazu");
            }
        }
        
        function __destruct() {
            $this->dbh = null;
        }
        
        function logovanje($ime, $prezime)
        {
            $sql = "select * from pisac where ime = '$ime' and prezime = '$prezime'";
            $res = $this->dbh->query($sql);
            return $res->fetch(PDO::FETCH_ASSOC);
        }
        
        function DajSvePisce()
        {
            $sql = "select * from pisac";
            $res = $this->dbh->query($sql);
            return $res->fetchAll(PDO::FETCH_ASSOC);
        }
        
        function DajPiscaByID($id)
        {
            $sql = "select * from pisac where id = ".$id;
            $res = $this->dbh->query($sql);
            return $res->fetch(PDO::FETCH_ASSOC);
        }
        
        function DajPiscaByIDAJAX($id)
        {
            $sql = "select * from pisac where id = ".$id;
            $res = $this->dbh->query($sql);
            $kor = $res->fetch(PDO::FETCH_ASSOC);
            
            $korisnik = new Pisac($kor['id'], $kor['ime'], $kor['prezime'], $kor['uloga'], 0);
            return json_encode($korisnik);
        }
        
        function DajKnjigeZaPisca($idPisca)
        {
            $sql = "select * from knjiga where pisac_id = ".$idPisca;
            $res = $this->dbh->query($sql);
            return $res->fetchAll(PDO::FETCH_ASSOC);
        }
        
        
        
        
        
        
        
        
        
        
        function dajCeluTabelu()
        {
            $pisci = $this->DajSvePisce();
            $niz = [];
            foreach ($pisci as $pisac)
            {
                $id = $pisac['id'];
                $ime = $pisac['ime'];
                $prezime = $pisac['prezime'];
                $uloga = $pisac['uloga'];
                
                $knjige = $this->DajKnjigeZaPisca($id);
                
                $nizknjiga = [];
                foreach ($knjige as $knjiga)
                {
                    $idK = $knjiga['id'];
                    $naslovK = $knjiga['naslov'];
                    $dat = $knjiga['dat_izdavanja'];
                    $pis = $knjiga['pisac_id'];
                    $nizknjiga[] = new Knjiga($idK, $naslovK, $dat, $pis);
                }
                
                $niz[] = new Pisac($id, $ime, $prezime, $uloga, $nizknjiga);
            }
            
            return json_encode($niz);
        }
        
        function PretraziZaKupca($tekst)
        {
            $pisci = "SELECT * FROM pisac WHERE ime LIKE '$tekst%'";
            $res = $this->dbh->query($sql);
            $pisci = $res->fetchAll(PDO::FETCH_ASSOC);
            
            $niz = [];
            foreach ($pisci as $pisac)
            {
                $id = $pisac['id'];
                $ime = $pisac['ime'];
                $prezime = $pisac['prezime'];
                $uloga = $pisac['uloga'];
                
                $knjige = $this->DajKnjigeZaPisca($id);
                
                $nizknjiga = [];
                foreach ($knjige as $knjiga)
                {
                    $idK = $knjiga['id'];
                    $naslovK = $knjiga['naslov'];
                    $dat = $knjiga['dat_izdavanja'];
                    $pis = $knjiga['pisac_id'];
                    $nizknjiga[] = new Knjiga($idK, $naslovK, $dat, $pis);
                }
                
                $niz[] = new Pisac($id, $ime, $prezime, $uloga, $nizknjiga);
            }
            
            return json_encode($niz);
        }
        
        function DajKnjigeZaPiscaInaslov($id, $tekst)
        {
            $sql = "select * from knjiga where pisac_id = ".$idPisca." and naslov LIKE '$tekst%'";
            $res = $this->dbh->query($sql);
            return $res->fetchAll(PDO::FETCH_ASSOC);
        }
                
        function PretraziZaKnjigu($tekst)
        {
            $pisci = $this->DajSvePisce();
            $niz = [];
            foreach ($pisci as $pisac)
            {
                $id = $pisac['id'];
                $ime = $pisac['ime'];
                $prezime = $pisac['prezime'];
                $uloga = $pisac['uloga'];
                
                $knjige = $this->DajKnjigeZaPiscaInaslov($id, $tekst);
                
                $nizknjiga = [];
                foreach ($knjige as $knjiga)
                {
                    $idK = $knjiga['id'];
                    $naslovK = $knjiga['naslov'];
                    $dat = $knjiga['dat_izdavanja'];
                    $pis = $knjiga['pisac_id'];
                    $nizknjiga[] = new Knjiga($idK, $naslovK, $dat, $pis);
                }
                
                $niz[] = new Pisac($id, $ime, $prezime, $uloga, $nizknjiga);
            }
            
            return json_encode($niz);
        }
        
        function obrisiKnjigu($id)
        {
            $sql = "DELETE FROM knjiga WHERE pisac_id=$id";
            $pdo_izraz = $this->dbh->exec($sql);
            
            $sql = "DELETE FROM pisac WHERE id=$id";
            $pdo_izraz = $this->dbh->exec($sql);
        }
    }
?>
