<?php
    class Writer
    {
        public $id;
        public $ime;
        public $prezime;
        public $uloga;
        public $books = [];
        
        public function __construct($id, $ime, $prezime, $uloga, $books) {
            $this->id = $id;
            $this->ime = $ime;
            $this->prezime = $prezime;
            $this->uloga = $uloga;
            $this->books = $books;
        }
    }

    class Book
    {
        public $id;
        public $naslov;
        public $dat_izdavanja;
        public $pisac_id;
        
        public function __construct($id, $naslov, $dat_izdavanja, $pisac_id) {
            $this->id = $id;
            $this->naslov = $naslov;
            $this->dat_izdavanja = $dat_izdavanja;
            $this->pisac_id = $pisac_id;
        }
    }

    class Db
    {
        const host = 'localhost';
        const db = 'biblioteka';
        const user = 'root';
        const pass = '';
        private $dbh;
        public function __construct() {
            $connection_string = "mysql:host=".self::host.";dbname=".self::db;
            $this->dbh = new PDO($connection_string, self::user, self::pass);
        }
        
        public function __destruct() {
            $this->dbh=null;
        }
        
        public function checkLogin($user, $pass)
        {
           $sql = "SELECT * FROM pisac WHERE ime='$user' AND prezime='$pass'";
           
           $res = $this->dbh->query($sql);
           if($res->rowCount() == 1)
           {
               $user = $res->fetch();
               
               return $user['id'];
           }
           return false;
        }
        
        public function getAllWriters($name=NULL, $lname=NULL)
        {
            $sql = "SELECT * FROM pisac";
            if(isset($name))
            {
                $sql .= " WHERE ime LIKE '%$name%'";
            }
            else if(isset ($lname))
            {
                $sql .= " WHERE prezime LIKE '%$lname%'";
            }
            $res = $this->dbh->query($sql);
            $rows = $res->fetchAll(PDO::FETCH_ASSOC);
            $writers = [];
            foreach($rows as $row){
                $writer['id'] = $row['id'];
                $writer['ime'] = $row['ime'];
                $writer['prezime'] = $row['prezime'];
                $writer['uloga'] = $row['uloga'];
            
                $writers[] = $writer;
            }
            
            return $writers;
        }
        
        public function getWriterById($id)
        {
            $sql = "SELECT * FROM pisac WHERE id='$id'";
            
            $res = $this->dbh->query($sql);
            
            $res = $res->fetch();
            
            $user['id'] = $res['id'];
            $user['ime'] = $res['ime'];
            $user['prezime'] = $res['prezime'];
            $user['uloga'] = $res['uloga'];
            
            return $user;
            
        }
        
        public function getBooks($title=NULL)
        {
            $sql = "SELECT * FROM knjiga";
            if(isset($title))
            {
                $sql .= " WHERE naslov LIKE '%$title%'";
            }
            
            $res = $this->dbh->query($sql);
            $rows = $res->fetchAll(PDO::FETCH_ASSOC);
            $books = [];
            foreach ($rows as $row) {
                $book = new Book($row['id'], $row['naslov'], $row['dat_izdavanja'], $row['pisac_id']);
                $books[] = $book;
            }
            return json_encode($books);
        }
        
        public function getBooksByWriterId($title=NULL, $id)
        {
            $sql = "SELECT * FROM knjiga WHERE pisac_id='$id'";
            if(isset($title))
            {
                $sql .= " AND naslov LIKE '%$title%'";
            }
            
            $res = $this->dbh->query($sql);
            $rows = $res->fetchAll(PDO::FETCH_ASSOC);
            $books = [];
            foreach ($rows as $row) {
                $book = new Book($row['id'], $row['naslov'], $row['dat_izdavanja'], $row['pisac_id']);
                $books[] = $book;
            }
            return $books;
        }
        
        public function getBooksByWriters($ime=NULL, $prezime=NULL, $title=NULL)
        {
            $writers = [];
            $rows = $this->getAllWriters($ime, $prezime);
            foreach ($rows as $row)
            {
                $writer = new Writer($row['id'], $row['ime'], $row['prezime'], $row['uloga'], $this->getBooksByWriterId($title, $row['id']));
                $writers[] = $writer;
            }
            
            return json_encode($writers);
        }
    }
