<?php

    class Pisac
    {
        public $id;
        public $ime;
        public $prezime;
        public $uloga;
        
        function __construct($id, $ime, $prezime, $uloga) {
            $this->id = $id;
            $this->ime = $ime;
            $this->prezime = $prezime;
            $this->uloga = $uloga;
        }

    }
    class Knjiga
    {
        public $id;
        public $naslov;
        public $dat_izdavanja;
        public $pisac_id;
        public $ime;
        public $prezime;
        
        function __construct($id, $naslov, $dat_izdavanja, $pisac_id, $ime, $prezime) {
            $this->id = $id;
            $this->naslov = $naslov;
            $this->dat_izdavanja = $dat_izdavanja;
            $this->pisac_id = $pisac_id;
            $this->ime = $ime;
            $this->prezime = $prezime;
        }

    }

    class Db
    {
        const host = "localhost";
        const user = "root";
        const pass = "";
        const dbname = "biblioteka";
        
        public $dbh;
        
        public function __construct() {
            $connStr = "mysql:host=".self::host.";dbname=".self::dbname;
            $this->dbh = new PDO($connStr, self::user, self::pass);
        }
        
        public function __destruct() {
            $this->dbh = null;
        }
        
        public function loginCheck($ime, $prezime)
        {
            $sql = "select * from pisac where ime='$ime' and prezime='$prezime'";
            $res = $this->dbh->query($sql);
            
            if($res->rowCount() > 0)
                return $res->fetch(PDO::FETCH_ASSOC);
            else
                return null;
        }
        
        public function getPisce()
        {
            $sql = "select * from pisac";
            $res = $this->dbh->query($sql);
            
            return $res->fetchAll(PDO::FETCH_ASSOC);
        }
        
        public function getPisacById($id)
        {
            $sql = "select * from pisac where id=$id";
            $res = $this->dbh->query($sql);
            
            $p = $res->fetch(PDO::FETCH_ASSOC);
            
            $pisac = new Pisac($p['id'], $p['ime'], $p['prezime'], $p['uloga']);
            return json_encode($pisac);
        }
        
        public function getKnjige()
        {
            $sql = "select k.id, naslov, dat_izdavanja, k.pisac_id, ime, prezime from knjiga k join pisac p on k.pisac_id = p.id";
            $res = $this->dbh->query($sql);
            
            $knjige = [];
            
            foreach($res->fetchAll(PDO::FETCH_ASSOC) as $knjiga)
            {
                $knjige[] = new Knjiga($knjiga['id'], $knjiga['naslov'], $knjiga['dat_izdavanja'], $knjiga['pisac_id'], $knjiga['ime'], $knjiga['prezime']);
            }
            return json_encode($knjige);
        }
        
        public function pretragaKnjigaPoPiscu($pisac)
        {
            $sql = "select k.id, naslov, dat_izdavanja, k.pisac_id, ime, prezime from knjiga k join pisac p on k.pisac_id = p.id where p.ime like '%$pisac%' or prezime like '%$pisac%'";
            $res = $this->dbh->query($sql);
            
            $knjige = [];
            
            $k = $res->fetchAll(PDO::FETCH_ASSOC);
            
            foreach($k as $knjiga)
            {
                $knjige[] = new Knjiga($knjiga['id'], $knjiga['naslov'], $knjiga['dat_izdavanja'], $knjiga['pisac_id'], $knjiga['ime'], $knjiga['prezime']);            
            }
            return json_encode($knjige);
            
        }
        
        public function pretragaKnjigaPoKnjizi($knjiga)
        {
            $sql = "select k.id, naslov, dat_izdavanja, k.pisac_id, ime, prezime from knjiga k join pisac p on k.pisac_id = p.id where naslov like '%$knjiga%'";
            $res = $this->dbh->query($sql);
            
            $knjige = [];
            
            $k = $res->fetchAll(PDO::FETCH_ASSOC);
            
            foreach($k as $knjiga)
            {
                $knjige[] = new Knjiga($knjiga['id'], $knjiga['naslov'], $knjiga['dat_izdavanja'], $knjiga['pisac_id'], $knjiga['ime'], $knjiga['prezime']);
            }
            return json_encode($knjige);
            
        }
        
        public function getPisacByIdNoJson($id)
        {
            $sql = "select * from pisac where id=$id";
            $res = $this->dbh->query($sql);
            
            return $res->fetch(PDO::FETCH_ASSOC);
        }
        
        public function delete($id)
        {
            $sql = "delete from knjiga where id=$id";
            $this->dbh->exec($sql);
        }
        
    }

?>
