<?php
    
    require_once './db.php';
    $db = new Db();

    session_start();
    if(!isset($_SESSION['user']))
        header("Location: login.php");
    
    $writer = $db->getPisacByIdNoJson($_SESSION['user']);
    
    if(isset($_GET['load']))
    {
        echo $db->getPisacById($_SESSION['user']);
        return;
    }
    
    if(isset($_GET['loadKnjige']))
    {
        echo $db->getKnjige();
        return;
    }
    
    if(isset($_GET['pretragaPoPiscu']))
    {
        echo $db->pretragaKnjigaPoPiscu($_GET['pretragaPoPiscu']);
        return;
    }
    
    if(isset($_GET['pretragaPoKnjizi']))
    {
        echo $db->pretragaKnjigaPoKnjizi($_GET['pretragaPoKnjizi']);
        return;
    }
    
    if(isset($_GET['obrisi']))
    {
        $db->delete($_GET['obrisi']);
        return;
    }

    if(isset($_GET['logout']))
    {
        session_destroy();
        header("Location: login.php");
    }
    
?>
<html>
    <head>
        <meta charset="UTF-8">
        <title></title>
    </head>
    <body onload="load()">
        <h3>Dobrodosli, <span id="imePisca"></span></h3>
        <h2>Pretraga biblioteke</h2>
        <a href="index.php?logout=">Logout</a><br>
        
        Pisac: <input type="text" onkeyup="pretraga()" name="pretragaPisac" id="pretragaPisac"> Knjiga: <input type="text" onkeyup="pretraga()" name="pretragaknjiga" id="pretragaKnjiga">
        <br><br>
        <table border="1" cellpadding="1" id="tabelaKnjiga">
            
        </table>
    
    
    </body>
    
    <script>
        
        function load()
        {
            ime = document.getElementById("imePisca");
            var x = new XMLHttpRequest();
            x.onreadystatechange = function()
            {
                if(x.readyState == 4 && x.status == 200)
                {
                    pisac = JSON.parse(x.responseText);
                    ime.innerHTML = pisac.ime + " " + pisac.prezime;
                }
            };
            x.open("get", "index.php?load=", true);
            x.send();
            loadKnjige()
            
        }
        
        function loadKnjige()
        {
            tabela = document.getElementById("tabelaKnjiga");
            tabela.innerHTML = "";
            var x = new XMLHttpRequest();
            x.onreadystatechange = function()
            {
                if(x.readyState == 4 && x.status == 200)
                {
                    knjige = JSON.parse(x.responseText);
                    for(i=0; i<knjige.length; i++)
                    {
                        tabela.innerHTML += "<tr><td>" + knjige[i].ime + " " +knjige[i].prezime + "</td><td>" + knjige[i].naslov +"</td><td><input type='button' value='Obrisi' onclick='obrisi(" + knjige[i].id +")'</td></tr>";
                       
                    }
                }
            };
            x.open("get", "index.php?loadKnjige=", true);
            x.send();
        }
        
        function pretraga()
        {
            tabela = document.getElementById("tabelaKnjiga");
            pisac = document.getElementById("pretragaPisac").value;
            knjiga = document.getElementById("pretragaKnjiga").value;
            
            tabela.innerHTML = "";
            
            if(pisac != "" && knjiga != "")
                alert("Moguca je pretraga samo po jednom kriterijumu");
            else
            {
                if(pisac != "")
                {
                    var x = new XMLHttpRequest();
                    x.onreadystatechange = function()
                    {
                        if(x.readyState == 4 && x.status == 200)
                        {
                            knjige = JSON.parse(x.responseText);
                            for(i=0; i<knjige.length; i++)
                            {
                                tabela.innerHTML += "<tr><td>" + knjige[i].ime + " " +knjige[i].prezime + "</td><td>" + knjige[i].naslov +"</td><td><input type='button' value='Obrisi' onclick='obrisi(" + knjige[i].id +")'</td></tr>";
                            }
                            
                        }
                    };
                    x.open("get", "index.php?pretragaPoPiscu="+pisac, true);
                    x.send();
                }
                
                else if(knjiga != "")
                {
                    var x = new XMLHttpRequest();
                    x.onreadystatechange = function()
                    {
                        if(x.readyState == 4 && x.status == 200)
                        {
                            knjige = JSON.parse(x.responseText);
                            for(i=0; i<knjige.length; i++)
                            {
                                tabela.innerHTML += "<tr><td>" + knjige[i].ime + " " +knjige[i].prezime + "</td><td>" + knjige[i].naslov +"</td><td><input type='button' value='Obrisi' onclick='obrisi(" + knjige[i].id +")'</td></tr>";
                            }
                        }
                    };
                    x.open("get", "index.php?pretragaPoKnjizi="+knjiga, true);
                    x.send();
                }
                else
                {
                    loadKnjige();
                }
            }
        }
        
        function obrisi(id)
        {
            var x = new XMLHttpRequest();
            x.onreadystatechange = function()
            {
                if(x.readyState == 4 && x.status == 200)
                {
                    load();
                }
            };
            x.open("get", "index.php?obrisi="+id, true);
            x.send();
        }
        
    </script>
</html>
